unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, FileCtrl, StdCtrls, Grids, ExtCtrls;

type
  TForm1 = class(TForm)
    FileBox: TFileListBox;
    Dir: TDirectoryListBox;
    Panel1: TPanel;
    selector: TDirectoryListBox;
    Panel2: TPanel;
    Button1: TButton;
    Splitter1: TSplitter;
    edExt: TEdit;
    Label1: TLabel;
    Panel3: TPanel;
    Panel4: TPanel;
    grid: TStringGrid;
    filecount: TLabel;
    DriveComboBox1: TDriveComboBox;
    procedure DirChange(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.DirChange(Sender: TObject);
begin
FileBox.Directory:=dir.Directory;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   rootDir:string;
procedure browsesub(const root:string);
var
   i,j,dirIterate:word;
   subdirs:TstringList;
begin
   subdirs:=Tstringlist.Create; //lista sto ke gi sodrzi subdirovite
   dir.Directory:=root;
   dir.OpenCurrent;
   {*** site file-s od tekovniot dir dodadi gi vo gridot *** }
   if FileBox.items.count>0 then
      for j:=0 to FileBox.items.count-1 do
         begin
         grid.cells[0,grid.RowCount-1]:=fileBox.Items[j];
         grid.cells[1,grid.RowCount-1]:=root;
         grid.RowCount:=grid.RowCount+1;
         end;
   {*** ako ne e posleden dir vo stebloto dodadi gi subdir-ovite vo listata ***}
   if not(dir.ItemIndex=dir.Items.Count-1) then
      begin
      for i:=dir.ItemIndex+1 to dir.Items.count-1 do
         begin
         if dir.itemindex=0 then
             subdirs.add(dir.Directory+dir.Items[i]) //ako e root ne treba backslash
           else
             subdirs.add(dir.Directory+'\'+dir.Items[i]);
         end;

      {*** rekurzija za sekoj subdir vo listata ***}
      for dirIterate:=0 to subdirs.Count-1 do
         browsesub(subdirs[dirIterate]);
      end;
   subdirs.Free;
end;
begin
FileBox.Mask:='*.'+edExt.text; // dodadi maska za extenzijata
grid.RowCount:=2;
grid.Cells[0,1]:='';
grid.Cells[1,1]:='';
grid.Cells[0,0]:='File';
grid.Cells[1,0]:='Path';
screen.Cursor:=-11;
browsesub(selector.Directory);
if grid.RowCount > 2 then
   grid.RowCount:=grid.RowCount-1;
if grid.cells[0,1]<>'' then
   filecount.Caption:='Total files matched: '+inttostr(grid.rowcount-1)
else
   filecount.Caption:='Total files matched: 0';
screen.Cursor:=0;
end;

end.
